unit tauselect;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
    ExtCtrls, StdCtrls, Buttons;
    procedure tauselection;//tauselect
    procedure graftauscale;{̓Ot\쐬tauselect}
    procedure graftauNdrow;{ʃ^Cv͂̓\tauselect}
    procedure graftauHdrow;{nCeV^Cv̓}tauselect}
    procedure CIRCLEtau(xpos,ypos,r: Double; s,e: Double);
    procedure eraseimage;//tauselect
    procedure taucheck; {͂̃Otɂ`FbN} //tauselect

type
    TForm3 = class(TForm)
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn1: TBitBtn;
    ScrollBar1: TScrollBar;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn3KeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn2KeyPress(Sender: TObject; var Key: Char);
  private
    { Private 錾 }
  protected
    procedure CreateParams(var Params: TCreateParams); Override;

  public
    { Public 錾 }
  end;

var
  Form3: TForm3;

implementation
uses Hspring,dataread,datain,startmenu,Check,Hgraf,material,newinput,Calcout,
     checkinput;
var
  LLB: string;

{$R *.DFM}

procedure eraseimage;//tauselect
var
  NewRect: TRect;
begin
  Form3.Caption := title;
  NewRect := Rect(0, 0,Form3.Image1.Width,Form3.Image1.Height);
  Form3.Image1.Canvas.Brush.Style := bsSolid;
  Form3.Image1.Canvas.Brush.Color := clWhite;
  Form3.Image1.Canvas.FillRect(NewRect);
end;

procedure CIRCLEtau(xpos,ypos,r: Double; s,e: Double);
var
  XT,YT,XB,YB,SX,SY,EX,EY: integer;
  HSY,HEY,SX1,SY1,EX1,EY1,HH: integer;
  rbak: Double;
begin
  rbak := r;
  HH := 420;
  XT := round(xpos - r);
  YT := HH - round(ypos + r);
  XB := round(xpos + r);
  YB := HH - round(ypos - r);
  SX1 := round(xpos + cos(s) * r);
  HSY :=round(ypos + sin(s) * r);
  SY1 := HH - HSY;
  EX1 := round(xpos + cos(e) * r);
  HEY :=round(ypos + sin(e) * r);
  EY1 := HH -HEY;
  if r < 10 then r := r * 10;
  SX := round(xpos + cos(s) * r);
  HSY :=round(ypos + sin(s) * r);
  SY := HH - HSY;
  EX := round(xpos + cos(e) * r);
  HEY :=round(ypos + sin(e) * r);
  EY := HH - HEY;
  Form3.Image1.Canvas.Arc(XT, YT, XB, YB, SX, SY, EX, EY);
  if rbak <= 1 then
    begin
      Form3.Image1.Canvas.MoveTo(SX1,SY1);
      Form3.Image1.Canvas.Lineto(EX1,EY1);
  	end;
end;

procedure  graftauHdrow;{nCeV^Cv̓}}
var
  IC:            integer;
  XC,YC,XC0,YC0: integer;
begin
  with Form3.Image1.Canvas do begin
    IC := 3;
    XC0 := round((602 - 146) / 19 * (IC - 3) + 146);
    YC0 := round((300 - 0.64 * TAUD3[IC - 3]));
    Pen.Style := psSolid;
    Pen.Width := 2;
    Pen.Color := clBlue;
    for IC := 4 TO 13 do
      begin
        XC := round((602 - 146) / 19 * (IC - 3) + 146);
        YC := round((300 - 0.64 * TAUD3[IC - 3]));
        moveto(XC0, YC0);
        lineto(XC, YC);
        XC0 := XC;
        YC0 := YC;
      end;
    IC := 3;
    XC0 := round((602 - 146) / 19 * (IC - 3) + 146);
    YC0 := round((300 - 0.64 * TAUD2[IC - 3]));
    Pen.Color := clred;
    for IC := 4 to 13 do
      begin
        XC := round((602 - 146) / 19 * (IC - 3) + 146);
        YC := round((300 - 0.64 * TAUD2[IC - 3]));
        moveto(XC0, YC0);
        lineto(XC, YC);
        XC0 := XC;
        YC0 := YC;
      end;
    Font.Color := clred;
    Font.height := 13;
    textout(10,60,'Hi-Tension Spring');
    Font.Color := clPurple;
    textout(50,74,'0.5 =<Dia<2.6');
    Font.Color := clBlue;
    textout(44,138,'0.12=<Dia<0.5');
    Pen.Width := 1;
  end;
end;

procedure graftauZdrow;//̓[̓\
var
   XC,YC: integer;
begin
  XC := 146;
  YC := 300;
  with Form3.Image1.Canvas do begin
    Pen.width := 2;
    Pen.Color := clFuchsia;
    moveto(XC, YC-1);
    XC := 602;
    lineto(XC, YC-1);
    Font.Color := clFuchsia;
    font.height := 13;
    textout(20,296,'͂^Ȃ');
  end;
end;

procedure graftauNdrow;{ʃ^Cv͂̓\}
var
  IC:             integer;
  XC,YC:          integer;
begin
  with Form3.Image1.Canvas do begin
    Pen.width := 1;
    Pen.Style := psSolid;
    Pen.Color := clGreen;
    IC := 3;
    XC := round((602 - 146) / 19 * (IC - 3) + 146);
    YC := round(300 - 0.64 * TAUD1[IC - 3]);
    moveto(XC, YC);
    for IC := 4 TO 22 do
      begin
        XC := round((602 - 146) / 19 * (IC - 3) + 146);
        YC := round(300 - 0.64 * TAUD1[IC - 3]);
        lineto(XC, YC);
      end;
    IC := 3;
    XC := round((602 - 146) / 19 * (IC - 3) + 146);
    YC := round(300 - 0.64 * TAUD0[IC - 3]);
    Form3.Image1.Canvas.moveto(XC, YC);
    for IC := 4 to 22 do
      begin
        XC := round((602 - 146) / 19 * (IC - 3) + 146);
        YC := round(300 - 0.64 * TAUD0[IC - 3]);
        lineto(XC, YC);
      end;
    moveto(146, 44);
    lineto(146, 300);
    moveto(602, 44);
    lineto(602, 300);
    Brush.Style := bsBDiagonal;
    Brush.Color := clYellow;
    FloodFill(200,220, clGreen, fsBorder);
    Font.Color := clMaroon;
    font.height := 13;
    textout(32,192,'NOMAL TYPE');
    textout(32,208,'JIS  (RS)');
  end;
end;

procedure selectlain;//IC\
var
  IC:             integer;
  XC,YC:          integer;
  TAUSE,taukeisu: double;
begin
  IC := 3;
  Form3.Image1.Canvas.Pen.width := 2;
  Form3.Image1.Canvas.Pen.Mode := pmNotXor;
  TAUSE := (TAUD0[IC - 3] + TAUD1[IC - 3]) /2;
  taukeisu := (TAUD0[IC - 3] - TAUD1[IC - 3]) /2 * taupps /100;
  XC := round((602 - 146) / 19 * (IC - 3) + 146);
  YC := round(300 - 0.64 * (TAUSE + taukeisu));
  Form3.Image1.Canvas.moveto(XC, YC);
  for IC := 4 to 22 do
    begin
      TAUSE := (TAUD0[IC - 3] + TAUD1[IC - 3]) /2;
      taukeisu := (TAUD0[IC - 3] - TAUD1[IC - 3]) /2 * taupps /100;
      XC := round((602 - 146) / 19 * (IC - 3) + 146);
      YC := round(300 - 0.64 * (TAUSE + taukeisu));
      Form3.Image1.Canvas.lineto(XC, YC);
    end;
  Form3.Image1.Canvas.Pen.Mode := pmCopy;
end;

procedure graftauscale;{̓Ot\쐬}
var
  Lgr:    string;
  IC:    integer;
  YC,XC,JC: integer;
begin
  with Form3.Image1.Canvas do begin
    Pen.width := 1;
    Pen.Color := clGreen;
    Pen.Style := psSolid;
    moveto(146, 44);
    lineTo(146, 300);
    lineTo(602, 300);
    lineTo(602, 44);
    Pen.Style := psDot;
    Pen.Color := clNavy;
    for IC := 1 to 4 do
      begin
        YC := (300 - 64 * IC);
        moveto(146, YC);
        lineTo(602, YC);
      end;
    for IC := 2 to 19 do
      begin
        XC := (602 - 146) div 19 * (IC - 1) + 146;
        moveto(XC, 44);
        lineTo(XC, 300);
      end;
    Font.Color := clFuchsia;
    Font.height := 13;
    if typS <> 'N' then
      begin
        for IC :=  0 to 4 do
          begin
            YC:= 38 + IC * 16 * 4 ;
              Lgr:= intTostr((4-IC)*100);
              if IC = 4 then textout(133, YC, Lgr)
                        else textout(119, YC,Lgr);
          end;
      end;
    Font.Color := clblack;
    for IC := 3 TO 22 do
      begin
        Lgr := intTostr(IC);
        JC := (IC - 3) * 3 * 8 + 140;
        textout(JC, 306, Lgr);
      end;
    if  jmode <> 0 then exit;
    Font.height := 13;
    textout(350, 320,'olw');
    font.Color := clNavy;
    Lgr:='͂őɗ^ꍇ́AnCeVI܂Bol萔͏Ȃ܂B';
    textout(20,332,Lgr);
    Lgr:='ʏ́Am ̕ʃ^CṽolIĉBԍՂ^CvłB';
    textout(20,345,Lgr);
    font.Color := clblack;
    Lgr:= 'SPRING TYPE   Hi-Tension = H , Normal = N';
    Font.height := 15;
    textout(5,360,Lgr);
    Font.Color := clRed;
    Lgr:= '͂̑I';
    Font.height := 20;
    textout(200,10,Lgr);
    Font.Color := clFuchsia;
    Lgr:= '͂^Ȃꍇ́A͖IB';
    Font.height := 15;
    textout(20,380,Lgr);
    Lgr:= '(́AȏꍇȂ̂ŁAʂ͑IȂB)';
    textout(20,397,Lgr);
  end;
end;

procedure tauselection;//tauselect
begin
  with Form3 do begin
    Form1.hide;
    Form2.hide;
    Form5.hide;
    Form7.hide;
    show;
    height := 460;
    width := 630;
    eraseimage;//tauselect
    graftauscale;{̓Ot\쐬}
    graftauNdrow;{ʃ^Cv͂̓\}
    graftauHdrow;{nCeV^Cv̓}}
    graftauZdrow;//̓[̓\
    with Bitbtn1 do begin
      Font.Name := 'lr SVbN';
      Font.height := 15;
      Caption := 'H';
      height := 20;
      width := 41;
      top := 362;
      Left := 380;
    end;
    with Bitbtn2 do begin
      Font.Name := 'lr SVbN';
      Font.height := 15;
      Caption := 'N';
      height := 20;
      width := 41;
      top := 362;
      Left := 436;
    end;
    with Bitbtn3 do begin
      Font.Name := 'lr SVbN';
      Font.height := 15;
      Caption := 'OK';
      height := 20;
      width := 41;
      top := 362;
      Left := 492;
    end;
    with Bitbtn5 do begin
      Font.Name := 'lr SVbN';
      Font.height := 15;
      Caption := 'Slɐݒ';
      height := 20;
      width := 100;
      top := 430;
      Left := 400;
    end;
    with Bitbtn6 do begin
      Font.Name := 'lr SVbN';
      Font.height := 15;
      Caption := '͖';
      height := 20;
      width := 100;
      top := 395;
      Left := 380;
      Font.Color := clFuchsia;
    end;
    with ScrollBar1 do begin
      Kind := sbVertical;
      height := 110;
      TOP := 140;
      LEFT := 130;
      width := 15;
      max := 100;
      min := -100;
      SmallChange := 1;
      LargeChange := 50;
    end;
    Bitbtn1.Visible := True;
    Bitbtn2.Visible := True;
    Bitbtn6.Visible := True;
    Bitbtn3.Visible := false;
    Bitbtn1.Enabled  := True;
    Bitbtn2.Enabled  := True;
    Bitbtn6.Enabled  := True;
    Bitbtn2.SetFocus;
    Bitbtn4.Visible := false;
    Bitbtn5.Visible := False;
    ScrollBar1.Visible := false;
    if incheck and 1 = 1 then
      begin
        case typS of
          'H': Bitbtn1.SetFocus;
          'N': Bitbtn2.SetFocus;
          'Z': Bitbtn6.SetFocus;
        end;
      end;
  end;
end;

procedure taucheck; {͂̃Otɂ`FbN} //tauselect
var
   XC,YC,MC:  Double;
begin
  Form3.show;
  Form1.hide;
  Form2.hide;
  Form6.hide;
  Form3.height := 400;
  Form3.width := 630;
  eraseimage;//tauselect
  graftauscale;{̓Ot\쐬tauselect}
  with Form3.Image1.Canvas do begin
    Font.color := clred;
    Font.height := 14;
    Textout(100,10,'------------  ol@@  -----------');
    Font.color:= clBlack;
    if tyPS = 'H' then graftauHdrow;{nCeV^Cv̓}tauselect}
    if tyPS = 'N' then graftauNdrow;{ʃ^Cv͂̓\tauselect}
    if tyPS = 'Z' then graftauZdrow;//̓[̓\
    MC := M;
    if MC < 3 then
      begin
        MC := 3;
        Font.color := clred;
        Font.height := 16;
        Textout(150,50,'olwRȉ');
      end;
    if MC > 22 then
      begin
        MC := 22;
        Font.color := clred;
        Font.height := 16;
        Textout(400,50,'olwQQȏ');
      end;
    XC := (602-146) / 19 * (MC - 3) + 146;
    YC := 300 - (64 / 100 * tau);
    YC := 420 - YC;
    Pen.Width := 2;
    Pen.color := clred;
    CIRCLEtau (XC, YC, 5, 0, pi * 2);
    CIRCLEtau (XC, YC, 4, 0, pi * 2);
    CIRCLEtau (XC, YC, 3, 0, pi * 2);
    CIRCLEtau (XC, YC, 2, 0, pi * 2);
    Font.color := clOlive;
    Pen.Width := 1;
    Font.height:= 14;
    Textout(8,338,'@@@@@@@otrg@djdx ');
  end;
  with Form3 do begin
    Bitbtn1.Visible := false;
    Bitbtn2.Visible := false;
    Bitbtn3.Visible := false;
    Bitbtn5.Visible := false;
    Bitbtn6.Visible := false;
    with Bitbtn4 do begin
      Font.Name := 'lr SVbN';
      Font.height := 14;
      height := 20;
      width := 60;
      top := 338;
      Left := 500;
      Visible := True;
      caption := 'PUSH';
      SetFocus;
    end;
  end;
  jmode := 2;

end;

procedure TForm3.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
  Params.WndParent := Application.Handle;
end;

procedure TForm3.FormCreate(Sender: TObject);
var
  Bitmap: Tbitmap;
begin
  Width := 630;
  Clientheight:= 460;
  BorderStyle := bsSingle;
  BorderIcons := [biSystemMenu,biminimize];
  Bitmap := TBitmap.Create;
  Bitmap.Width := ClientWidth;
  Bitmap.height:= ClientHeight;
  Image1.Picture.Graphic := Bitmap;
  Bitmap.Free;
  top := (Screen.Height - Height) div 2;
  left := (Screen.Width - Width) div 2;
end;

procedure TForm3.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Form1.close;
end;

procedure TForm3.BitBtn1Click(Sender: TObject);
begin
  typS := 'H';
  CMAX := 13;
  Bitbtn5.Visible  := False;
  eraseimage;//tauselect
  ClientHeight := 440;
  graftauscale;{̓Ot\쐬}
  graftauHdrow;{nCeV^Cv̓}}
  ScrollBar1.Visible := false;
  Bitbtn3.Visible := True;
  Bitbtn2.Enabled  := True;
  Bitbtn1.Enabled  := False;
  Bitbtn6.Enabled := True;
  Bitbtn3.SetFocus;
end;

procedure TForm3.BitBtn2Click(Sender: TObject);
begin
  CMAX := 22;
  typS := 'N';
  if incheck and 1 = 0 then taupps := 0;
  LLB := '';
  ClientHeight := 460;
  eraseimage;//tauselect
  graftauscale;{̓Ot\쐬}
  graftauNdrow;{ʃ^Cv͂̓\}
  selectlain;//IC\
  with Image1.Canvas do begin
    Font.color := clred;
    Font.height := 12;
    Textout(10,415,'XN[o[ړƁA͂̃J[üʒuύXo܂B');
    Textout(10,428,'SԐxǂo܂B');
    Textout(10,441,'KvAύXȂłB');
  end;
  ScrollBar1.Visible := true;
  Bitbtn3.Visible := True;
  Bitbtn5.Visible := False;
  Bitbtn1.Enabled  := True;
  Bitbtn2.Enabled  := False;
  Bitbtn6.Enabled := True;
  Bitbtn3.SetFocus;
  ScrollBar1.Position := round(-taupps);
end;

procedure TForm3.BitBtn3Click(Sender: TObject);
begin
  case dspmode of
    4,12: begin
            hide;
            if TypS = 'Z' then
              begin
                Form1.show;
                diregapin;//Ԋuԓ
                exit;
              end;
            Form7.show;
            incheck := incheck or 1;
            diregap := 0;//Ԋǔ
            checkinputdata;//checkinput;
          end;
    0,1:  begin
            hide;
            if TypS = 'Z' then
              begin
                Form1.show;
                diregapin;//Ԋuԓ
                exit;
              end;
            Form1.hide;
            Form5.show;
            diregap := 0;//Ԋǔ
            incheck := incheck or 1;
            indatadisp;//͂c`s`\  newinput
          end;
  end;
  ScrollBar1.Visible := False;
  Bitbtn5.Visible := False;
end;

procedure TForm3.BitBtn4Click(Sender: TObject);
begin
  Form3.hide;
  Form1.show;
  materialcheck; {e͂̃Otɂ`FbN}//material
end;

procedure TForm3.ScrollBar1Change(Sender: TObject);
begin
  with Image1.Canvas do begin
    Font.height := 17;
    selectlain;//IC\
    taupps := ScrollBar1.Position;
    taupps := - taupps;
    selectlain;//IC\
    Font.color := clwhite;
    Textout(30,50,'΍');
    Textout(80,50,LLB);
    if taupps <> 0 then
      begin
        LLB := format('%2.1f',[taupps]);
        Font.color := clblue;
        Textout(30,50,'΍');
        Textout(80,50,LLB);
        Bitbtn5.Visible := True;
      end;
  end;
end;

procedure TForm3.BitBtn5Click(Sender: TObject);
begin
  selectlain;//IC\
  taupps := 0;
  selectlain;//IC\
  Image1.Canvas.Font.color := clwhite;
  Image1.Canvas.Textout(80,50,LLB);
  Image1.Canvas.Textout(30,50,'΍');
  ScrollBar1.Position := 0;
end;

procedure TForm3.BitBtn6Click(Sender: TObject);
begin
  CMAX := 22;
  typS := 'Z';
  taupps := 0;
  ClientHeight := 440;
  eraseimage;//tauselect
  graftauscale;{̓Ot\쐬}
  graftauZdrow;//̓[̓\
  ScrollBar1.Visible := false;
  Bitbtn1.Enabled := true;
  Bitbtn2.Enabled := True;
  Bitbtn3.Visible := True;
  Bitbtn5.Visible := False;
  Bitbtn6.Enabled := False;
  Bitbtn3.SetFocus;
  ScrollBar1.Position := round(-taupps);
end;

procedure TForm3.BitBtn3KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then
    begin
      case dspmode of
        4,12: begin
                hide;
                if TypS = 'Z' then
                  begin
                    Form1.show;
                    exit;
                  end;
                Form7.show;
                checkinputdata;//checkinput;
              end;
       0,1:   begin
                hide;
                if TypS = 'Z' then
                  begin
                    Form1.show;
                    exit;
                  end;
                Form1.hide;
                Form5.show;
                indatadisp;//͂c`s`\  newinput
              end;
      end;
      ScrollBar1.Visible := False;
      Bitbtn5.Visible := False;
    end;
  if key = #13 then
    begin
      case dspmode of
        4,12: begin
                hide;
                if TypS = 'Z' then
                  begin
                    Form1.show;
                    diregapin;//Ԋuԓ
                    exit;
                  end;
                Form7.show;
                incheck := incheck or 1;
                diregap := 0;//Ԋǔ
                checkinputdata;//checkinput;
              end;
        0,1:  begin
                hide;
                if TypS = 'Z' then
                  begin
                    Form1.show;
                    diregapin;//Ԋuԓ
                    exit;
                  end;
                Form1.hide;
                Form5.show;
                diregap := 0;//Ԋǔ
                incheck := incheck or 1;
                indatadisp;//͂c`s`\  newinput
              end;
      end;
      ScrollBar1.Visible := False;
      Bitbtn5.Visible := False;
    end;
end;

procedure TForm3.BitBtn2KeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then
    begin
      case dspmode of
        4,12: begin
                hide;
                if TypS = 'Z' then
                  begin
                    Form1.show;
                    exit;
                  end;
                Form7.show;
                checkinputdata;//checkinput;
              end;
        0,1:  begin
                hide;
                if TypS = 'Z' then
                  begin
                    Form1.show;
                    exit;
                  end;
                Form1.hide;
                Form5.show;
                indatadisp;//͂c`s`\  newinput
                end;
      end;
    end;
  if key = #13 then
    begin
      CMAX := 22;
      typS := 'N';
      taupps := 0;
      ClientHeight := 460;
      eraseimage;//tauselect
      graftauscale;{̓Ot\쐬}
      graftauNdrow;{ʃ^Cv͂̓\}
      selectlain;//IC\
      with Image1.Canvas do begin
        Font.color := clred;
        Font.height := 12;
        Textout(10,415,'XN[o[ړƁA͂̃J[üʒuύXo܂B');
        Textout(10,428,'SԐxǂo܂B');
        Textout(10,441,'KvAύXȂłB');
      end;
      ScrollBar1.Visible := true;
      Bitbtn3.Visible := True;
      Bitbtn5.Visible := False;
      Bitbtn1.Enabled  := True;
      Bitbtn2.Enabled  := False;
      Bitbtn6.Enabled := True;
      Bitbtn3.SetFocus;
      ScrollBar1.Position := round(-taupps);
    end;
end;

end.

