unit Gpout;

interface
  procedure PBANEdrow(BTYPE:integer;a, d, L, PAI, PG, A4, A5, A6, leng, n: Double; poy: integer);
  procedure PGAKUMALU(xpos,ypos,leng,a,d,na,keisu: Double);
  procedure PMALUFUCK(xpos,ypos,leng,a,d,na,keisu: Double);
  procedure PGAKUSITI (xpos,ypos,leng,a,d,na,keisu,A4: Double);
  procedure PMALUSITI(xpos,ypos,leng,a,d,na,keisu,A4: Double);
  procedure PRIYOSITEI(xpos,ypos,leng,a,d,na,keisu,A5,A6: Double);
  procedure PLINE(xpos1,ypos1,xpos2,ypos2: Double);

implementation

uses Hspring,Graphics,Printers,SysUtils;

var
   Pkeisu:   double;//ʃTCYƁAv^[TCY̔

procedure PCIRCLE(xpos, ypos, r: Double; s, e: Double);
var
     XT,YT,XB,YB,SX,SY,EX,EY,HH: integer;
     HSY,HEY: integer;
begin
  HH := round(400  * Pkeisu);//xW ɏɕϊ
  XT := round(xpos - r);
  YT := HH - round(ypos + r);
  XB := round(xpos + r);
  YB := HH - round(ypos - r);
  if r < 10 then r := r * 10;
  SX := round(xpos + cos(s) * r);
  HSY :=round(ypos + sin(s) * r);
  SY := HH - HSY;
  EX := round(xpos + cos(e) * r);
  HEY :=round(ypos + sin(e) * r);
  EY := HH - HEY;
  Printer.Canvas.Arc(XT, YT, XB, YB, SX, SY, EX, EY);
end;

procedure PYA(YAXPOS,YAYPOS,Q: Double);
var
   XX, YY: integer;
   YAQ,QYAS,QYAE: Double;
   LENGYAS,LENGYAE,OFFYAS,OFFYAE: integer;
begin
  XX:= round(YAXPOS);
  YY:= round(YAYPOS);
  YAQ:= PI/12;
  QYAS := Q + YAQ;
  QYAE := Q - YAQ;
  if QYAS > PI * 2 then QYAS := QYAS - PI * 2;
  if QYAE > PI * 2 then QYAE := QYAE - PI * 2;
  if QYAS < 0 then QYAS := QYAS + PI * 2;
  if QYAE < 0 then QYAE := QYAE + PI * 2;
  LENGYAS := round(COS(QYAS) * 10 * Pkeisu);
  LENGYAE := round(COS(QYAE) * 10 * Pkeisu);
  OFFYAS := round(SIN(QYAS) * 10 * Pkeisu);
  OFFYAE := round(SIN(QYAE) * 10 * Pkeisu);
  PLINE(XX + LENGYAS, YY + OFFYAS, XX, YY);
  PLINE(XX, YY, XX + LENGYAE, YY + OFFYAE);
end;

procedure PLINE(xpos1,ypos1,xpos2,ypos2: Double);
var
   X1,Y1,X2,Y2: integer;
begin
  X1 := round(xpos1);
  Y1 := round(400  * Pkeisu - ypos1);//xWVpositionɏɕϊ
  X2 := round(xpos2);
  Y2 := round(400  * Pkeisu - ypos2);//xWVpositionɏɕϊ
  Printer.Canvas.MoveTo(X1,Y1);
  Printer.Canvas.Lineto(X2,Y2);
end;

procedure POutGDBCS(xpos,ypos: Double; L: string; okisa: Double);
var
   XX, YY: integer;
begin
  Printer.Canvas.Font.Height:= round(okisa);
  XX:= round(xpos);
  YY:= round(ypos);
  Printer.Canvas.Brush.Style := bsClear;
  Printer.Canvas.Textout(XX,YY,L);
end;

procedure PBANEdrow(BTYPE:integer;
                          a, d, L, PAI, PG, A4, A5, A6, leng, n: Double; poy: integer);
{BTYPE = 1: 'P@tہ@Q@ہ@R@tЎw@S@ەЎw@T@w@@
{A = 12: 'a}
{D = 2: 'a}
{L = 70: 'w蒷}
{LENG = 49.8: 'R}
{PaI = .015: '}
{P = 3: 'w蒷׏d}
{A4 = 10: 'tbNЕw蒷}
{A5 = 6: 'tbNw蒷̕Е̎w蒷}
{A6 = 16: 'tbNw蒷̕Е̎w蒷}
var
  LS: string;
  LD: string;
  A7,xpos,ypos,keisu,gpos: Double;
  mnagasa:      integer;
  RLENG,NIKI,DXPOS:  Double;
begin
  if printer.PageHeight > printer.PageWidth then Pkeisu := printer.PageWidth / 640
                                            else Pkeisu :=  printer.PageHeight / 640;
  printer.Canvas.Font.Color := clRed;
  gpos := 400 * Pkeisu - poy;
  xpos := 150 * Pkeisu;
  RLENG := 1;
  ypos := 280  * Pkeisu;
  POutGDBCS(Xpos, 20 * Pkeisu + poy, 'ol}Ql\', 15 * Pkeisu);
  A7 := PG * 0.15;
  LD := '';
  LS := '';
  if PG < 0.1 then
    begin
      LD := format('%1.4f',[PG]);
      LS := format('%1.4f',[A7]);
    end;
  if (PG >= 0.1) and (PG < 1) then
    begin
      LD := format('%1.3f',[PG]);
      LS := format('%1.3f',[A7]);
    end;
  if (PG >= 1) and (PG < 10) then
    begin
      LD := format('%2.2f',[PG]);
      LS := format('%2.2f',[A7]);
    end;
  if (PG >= 10) and (PG < 100) then
    begin
      LD := format('%3.1f',[PG]);
      LS := format('%3.1f',[A7]);
    end;
  if PG >= 100 then
    begin
      LD := format('%6.0f',[PG]);
      LS := format('%6.0f',[A7]);
    end;
  LS := LD + 'm}' + LS + 'm';
  Form1.Image1.Canvas.Font.Height := 15;
  mnagasa := Form1.Image1.Canvas.TextWidth(LS);
  keisu := (640 - 200 - mnagasa - 100) / L * Pkeisu;
  Printer.Canvas.Font.Color := clBlack;
  POutGDBCS(xpos + L * keisu + 5 * Pkeisu, ypos - 182 * Pkeisu + poy, LS, 15 * Pkeisu);
  case BTYPE  of
    1: PGAKUMALU(xpos, gpos - ypos, leng, a, d, n, keisu);
    2: PMALUFUCK(xpos, gpos - ypos, leng, a, d, n, keisu);
    3: PGAKUSITI(xpos, gpos - ypos, leng, a, d, n, keisu, A4);
    4: PMALUSITI(xpos, gpos - ypos, leng, a, d, n, keisu, A4);
    5: PRIYOSITEI(xpos, gpos -ypos, leng, a, d, n, keisu, A5, A6);
  end;
  case BTYPE of
    1: RLENG := (a - d) * 1.1;
    2: RLENG := (a - d) * 0.8;
    3: RLENG := A4;
    4: RLENG := A4;
  end;
  Printer.Canvas.Font.Color := clBlack;
  PLINE (xpos, gpos - (ypos - 5 * Pkeisu),xpos, gpos - (ypos - 220 * Pkeisu));
  PLINE (xpos + leng * keisu, gpos - (ypos - 5 * Pkeisu),xpos + leng * keisu, gpos - (ypos - 85 * Pkeisu));
  PLINE (xpos, gpos - (ypos - 80 * Pkeisu),xpos + leng * keisu, gpos - (ypos - 80 * Pkeisu));
  PYA(xpos, gpos -(ypos - 80 * Pkeisu), 0);
  PYA(xpos + leng * keisu, gpos - (ypos - 80 * Pkeisu), pi);
  PLINE(xpos + (leng - RLENG + d / 2) * keisu, gpos - (ypos - (a - d) / 2 * keisu),
                       xpos + leng * keisu + 60 * Pkeisu, gpos - (ypos - (a - d) / 2 * keisu));
  PLINE(xpos + (leng - RLENG + d / 2) * keisu,gpos - (ypos + (a - d) / 2 * keisu),
                       xpos + leng * keisu + 60 * Pkeisu, gpos - (ypos + (a - d) / 2 * keisu));
  PLINE(xpos + leng * keisu + 55 * Pkeisu, gpos-(ypos - (a - d) / 2 * keisu),
                       xpos + leng * keisu + 55 * Pkeisu, gpos - (ypos + (a - d) / 2 * keisu));
  PYA(xpos + leng * keisu + 55 * Pkeisu, gpos - (ypos - (a - d) / 2 * keisu), pi / 2 + pi);
  PYA(xpos + leng * keisu + 55 * Pkeisu, gpos -(ypos + (a - d) / 2 * keisu), Pi / 2);
  PLINE(xpos + leng * keisu, gpos - (ypos - 85 * Pkeisu),
                       xpos + leng * keisu, gpos - (ypos - 100 * Pkeisu));
  PLINE(xpos + L * keisu, gpos - (ypos - 180 * Pkeisu),
                       xpos + L * keisu, gpos - (ypos - 220 * Pkeisu));
  PLINE(xpos, gpos - (ypos - 215 * Pkeisu), xpos + L * keisu, gpos - (ypos - 215 * Pkeisu));
  PYA(xpos, gpos - (ypos - 215 * Pkeisu), 0);
  PYA(xpos + L * keisu, gpos -(ypos - 215 * Pkeisu), pi);
  Printer.Canvas.Pen.Width := 2;
  PLINE(xpos + leng * keisu, gpos - (ypos - 104 * Pkeisu),
                       xpos + L * keisu, gpos - (ypos - 175 * Pkeisu));
  PLINE(xpos + L * keisu, gpos - (ypos - 175 * Pkeisu),
                       xpos + L * keisu, gpos - (ypos - 104 * Pkeisu));
  PLINE(xpos + L * keisu, gpos - (ypos - 104 * Pkeisu),
                       xpos + leng * keisu, gpos-(ypos - 104 * Pkeisu));
  Printer.Canvas.Pen.Width := 1;
  NIKI := a - d;
  LD := format('%3.1f',[NIKI]);
  LS := ''+ LD + '';
  POutGDBCS(xpos + leng * keisu + 60 * Pkeisu, ypos - 8 * Pkeisu + poy, LS, 15 * Pkeisu);
  LD := Formatfloat('##0.#',leng);
  LS := LD + 'mm';
  DXPOS := Form1.Image1.Canvas.TextWidth(LS) / 2 * Pkeisu;
  POutGDBCS(xpos + leng * keisu / 2 - DXPOS, ypos - 97 * Pkeisu + poy, LS, 15 * Pkeisu);
  LS := Format('%5.1f',[L]);
  LS := LS + 'mm';
  DXPOS := Form1.Image1.Canvas.TextWidth(LS) / 2 * Pkeisu;
  POutGDBCS(xpos + L * keisu / 2 - DXPOS, ypos - 232 * Pkeisu + poy, LS, 15 * Pkeisu);
  if PAI < 0.001 then LD := format('%1.6f',[PAI]);
  if (PAI >= 0.001) and (PAI < 0.01) then LD := format('%1.5f',[PAI]);
  if (PAI >= 0.01)  and (PAI < 0.1)  then LD := format('%1.4f',[PAI]);
  if (PAI >= 0.1)   and (PAI < 1)    then LD := format('%1.3f',[PAI]);
  if (PAI >= 1)     and (PAI < 10)   then LD := format('%2.2f',[PAI]);
  if (PAI >= 10)    and (PAI < 100)  then LD := format('%3.1f',[PAI]);
  if PAI >= 100  then LD := format('%6.0f',[PAI]);
  LS := 'i' + LD + 'mj';
  POutGDBCS(xpos + L * keisu + 5 * Pkeisu, ypos - 114 * Pkeisu + poy, LS, 15 * Pkeisu);
end;


procedure PGAKUMALU(xpos,ypos,leng,a,d,na,keisu: Double);
var
  I,Ns,cnan,NT:                   integer;
  ADIA,DIAW,JIUCH,NIKEI,GIKEI,RWIRE,RADIA,GFUCK: Double;
  LFUCK,ALFUCK,LFUCKS,LFUCKT,QFUCKS,QFUCKT,QCALC:   Double;
  PICH,CKAKU:  Double;
begin
  Ns := round(int(na));
  NT := round(na * 4);
  ADIA := a * keisu;            {a}
  DIAW := d * keisu;            {a}
  JIUCH := leng * keisu;        {}
  NIKEI := ADIA - DIAW;       {a}
  GIKEI := ADIA + DIAW;       {Oa}
  RWIRE := DIAW / 2;            {a}
  RADIA := ADIA / 2;            {a}
  GFUCK := NIKEI * 1.1;          {tbN}
  LFUCK := GFUCK - NIKEI / 2 + RWIRE;
  ALFUCK := LFUCK + NIKEI / 2;
  LFUCKS := SQRT(SQR(LFUCK)+ SQR(RADIA));
  LFUCKT := SQRT(SQR(LFUCKS) - SQR(RADIA));
  QFUCKS := ARCTAN(RADIA / LFUCKT);
  QFUCKT := ARCTAN(LFUCK / RADIA);
  QCALC := QFUCKT - QFUCKS;
  Printer.Canvas.Pen.Color := clBlack;
{tbN}
  if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                  else Printer.Canvas.Pen.Width := 1;
  PCIRCLE (xpos + NIKEI / 2, ypos, NIKEI / 2, QCALC, PI + PI / 2 + PI / 6);
  PCIRCLE (xpos + NIKEI / 2, ypos, GIKEI / 2, QCALC, PI + PI / 2 + PI / 6);
  PCIRCLE (xpos + ALFUCK, ypos - RADIA, RWIRE, PI + QCALC, QCALC);
  PLINE(xpos + NIKEI / 2 + GIKEI / 2 * COS(QCALC),ypos + GIKEI / 2 * SIN(QCALC),
        	      xpos + GFUCK + RWIRE + RWIRE * COS(QCALC),ypos - RADIA - RWIRE * SIN(QCALC));
  PLINE(xpos + NIKEI / 2 + NIKEI / 2 * COS(QCALC),ypos +NIKEI / 2 * SIN(QCALC),
    		        xpos + GFUCK + RWIRE - RWIRE * COS(QCALC),ypos - RADIA - RWIRE * SIN(QCALC));
  PLINE (xpos + NIKEI / 2 + NIKEI / 2 * SIN(PI / 6),ypos - NIKEI / 2 * COS(PI / 6),
        	      xpos + NIKEI / 2 + GIKEI / 2 * SIN(PI / 6),ypos - GIKEI / 2 * COS(PI / 6));
{RC}
  PICH := (JIUCH - ALFUCK * 2) / na;
  CKAKU:= ARCTAN(PICH / 2 / ADIA);
  Printer.Canvas.Brush.Style := bsClear;
  Printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PLINE(xpos + ALFUCK + PICH * (I - 1) + RWIRE * COS(CKAKU),ypos - (RADIA + RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),ypos +( RADIA - RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * (I - 1) - RWIRE * COS(CKAKU),ypos - (RADIA - RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),ypos +(RADIA + RWIRE * SIN(CKAKU)));
	  end;
  if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                   else printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PCIRCLE(xpos + ALFUCK + PICH * I,ypos - RADIA,RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2,ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),ypos - (RADIA - RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),ypos -( RADIA + RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),ypos +( RADIA - RWIRE * SIN(CKAKU)));
    end;
  I := Ns;
  cnan := NT mod 4; {ǂ`FbN}
  if cnan = 0 then //EtbN
    begin
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos,NIKEI / 2, PI + PI / 2 - PI / 6, PI - QCALC);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos,GIKEI / 2, PI + PI / 2 - PI / 6, PI - QCALC);
      PCIRCLE(xpos + JIUCH - ALFUCK, ypos - RADIA,RWIRE, PI - QCALC, 2 * PI - QCALC);
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * COS(QCALC),ypos + GIKEI / 2 * SIN(QCALC),
            xpos + JIUCH - GFUCK - RWIRE - RWIRE * COS(QCALC),ypos - RADIA + RWIRE * SIN(QCALC));
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * COS(QCALC),ypos + NIKEI / 2 * SIN(QCALC),
            xpos + JIUCH - GFUCK - RWIRE + RWIRE * COS(QCALC),ypos - RADIA - RWIRE * SIN(QCALC));
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(PI / 6),ypos - NIKEI / 2 * COS(PI / 6),
            xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(PI / 6),ypos - GIKEI / 2 * COS(PI / 6));
      PCIRCLE(xpos + ALFUCK + PICH * I,ypos - RADIA,RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2,ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),ypos - (RADIA - RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),ypos -( RADIA + RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),ypos +( RADIA - RWIRE * SIN(CKAKU)));
{EcS}
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
            xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
    end;
  if cnan = 2 then //ODT
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),ypos + RADIA + RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),ypos - RADIA + RWIRE * SIN(CKAKU));
      PLINE(xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),ypos + RADIA - RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),ypos - RADIA - RWIRE * SIN(CKAKU));
      if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                       else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + ALFUCK + PICH * I,ypos - RADIA, RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2,ypos + RADIA, RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),ypos - (RADIA - RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),ypos -( RADIA + RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),ypos +( RADIA - RWIRE * SIN(CKAKU)));
      PCIRCLE(xpos + JIUCH - NIKEI / 2,ypos, NIKEI / 2, PI + QCALC, PI / 2 + PI / 6);
      PCIRCLE(xpos + JIUCH - NIKEI / 2,ypos, GIKEI / 2, PI + QCALC, PI / 2 + PI / 6);
      PCIRCLE(xpos + JIUCH - ALFUCK,ypos + RADIA, RWIRE, 2 * PI - QCALC, PI + QCALC);
      PLINE(xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * COS(QCALC),ypos - GIKEI / 2 * SIN(QCALC),
            xpos + JIUCH - GFUCK - RWIRE - RWIRE * COS(QCALC),ypos + RADIA + RWIRE * SIN(QCALC));
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * COS(QCALC),ypos - NIKEI / 2 * SIN(QCALC),
            xpos + JIUCH - GFUCK - RWIRE + RWIRE * COS(QCALC),ypos + RADIA + RWIRE * SIN(QCALC));
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(PI / 6),ypos + NIKEI / 2 * COS(PI / 6),
            xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(PI / 6),ypos + GIKEI / 2 * COS(PI / 6));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,xpos + JIUCH - NIKEI / 2,
                        ypos + RADIA + DIAW + 5 * Pkeisu);
    end;
  if cnan = 1 then //OBQT
	  begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - ALFUCK + RWIRE * COS(CKAKU),ypos - RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),ypos - RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - ALFUCK - RWIRE * COS(CKAKU),ypos + RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),ypos - RADIA + RWIRE * SIN(CKAKU));
      if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                       else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH - ALFUCK,ypos, RWIRE, PI /2 , PI + PI / 2);
      PCIRCLE(xpos + JIUCH + RWIRE,ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,xpos + JIUCH - ALFUCK, ypos + RWIRE);
      PLINE (xpos + JIUCH + RWIRE, ypos - RWIRE,xpos + JIUCH - ALFUCK, ypos - RWIRE);
      Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH - ALFUCK,ypos, RWIRE, PI * 2 - QCALC, PI / 2);
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(PI / 6),ypos + RWIRE,
            xpos + JIUCH - RADIA - RADIA * SIN(PI / 6),ypos - RWIRE);
      PLINE(xpos + JIUCH - NIKEI / 2,ypos - DIAW - 5 * Pkeisu,
            xpos + JIUCH - NIKEI / 2,ypos + DIAW + 5 * Pkeisu);
    end;
  if cnan = 3 then //OBVT
	  begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),ypos + RADIA + RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),ypos - RADIA + RWIRE * SIN(CKAKU));
      PLINE(xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),ypos + RADIA - RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),ypos - RADIA - RWIRE * SIN(CKAKU));
      if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                       else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + ALFUCK + PICH * I + PICH / 2,ypos + RADIA, RWIRE, PI * 2 - CKAKU, PI + CKAKU);
      PCIRCLE(xpos + JIUCH - ALFUCK,ypos, RWIRE, PI / 2, QCALC);
      PCIRCLE(xpos + JIUCH + RWIRE,ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,xpos + JIUCH - ALFUCK, ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE,ypos - RWIRE,xpos + JIUCH - ALFUCK, ypos - RWIRE);
      PLINE(xpos + JIUCH - ALFUCK - RWIRE * COS(CKAKU),ypos - RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - ALFUCK + RWIRE * COS(CKAKU),ypos + RWIRE * SIN(CKAKU),
            xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),ypos + RADIA + RWIRE * SIN(CKAKU));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(PI / 6),ypos + RWIRE,
            xpos + JIUCH - RADIA - RADIA * SIN(PI / 6),ypos - RWIRE);
      PCIRCLE (xpos + ALFUCK + PICH * I,ypos - RADIA, RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE (xpos + ALFUCK + PICH * I - PICH / 2,ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),ypos - (RADIA - RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),ypos -( RADIA + RWIRE * SIN(CKAKU)),
            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),ypos +( RADIA - RWIRE * SIN(CKAKU)));
      PLINE(xpos + JIUCH - NIKEI / 2,ypos - DIAW - 5 * Pkeisu,xpos + JIUCH - NIKEI / 2,ypos + DIAW + 5 * Pkeisu);
    end;
  PLINE (xpos - DIAW - 5 * Pkeisu, ypos,xpos + JIUCH + DIAW + 5 * Pkeisu,ypos);
  PLINE (xpos + NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,xpos + NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
end;

procedure PMALUFUCK(xpos,ypos,leng,a,d,na,keisu: Double);
var
  I,Ns,cnan,NT:                   integer;
  ADIA,DIAW,JIUCH,NIKEI,GIKEI,RWIRE,RADIA,GFUCK: Double;
  LFUCK,ALFUCK:   Double;
  PICH,CKAKU,RDXPOS:  Double;
begin
  Ns := round(int(na));
  NT := round(na * 4);
  ADIA := a * keisu;            {a}
  DIAW := d * keisu;            {a}
  JIUCH := leng * keisu;        {}
  NIKEI := ADIA - DIAW;       {a}
  GIKEI := ADIA + DIAW;       {Oa}
  RWIRE := DIAW / 2;            {a}
  RADIA := ADIA / 2;            {a}
  GFUCK := NIKEI * 0.8;          {tbN}
  LFUCK := GFUCK - NIKEI / 2 + RWIRE;
  ALFUCK := LFUCK + NIKEI / 2;
  PICH := (JIUCH - ALFUCK * 2) / na;
  CKAKU:= ARCTAN(PICH / 2 / ADIA);
  RDXPOS := JIUCH - ALFUCK
                  + sin((PI / 2 - CKAKU) / 2)/cos((PI / 2 - CKAKU) / 2)
                  * RADIA * 3 / 5;
{tbN}
  Printer.Canvas.Brush.Style := bsClear;
  Printer.Canvas.Pen.Color := clBlack;
  if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
    	             else Printer.Canvas.Pen.Width := 1;
  PCIRCLE(xpos + NIKEI / 2, ypos, NIKEI / 2, PI / 2, PI + PI / 2);
  PCIRCLE(xpos + NIKEI / 2, ypos, GIKEI / 2, PI / 2, PI + PI / 2);
  PCIRCLE(xpos + ALFUCK, ypos - RADIA, RWIRE, PI, 2 * PI);
  PCIRCLE(xpos + NIKEI / 2, ypos + NIKEI / 5, NIKEI * 3 / 10, 0, PI / 2);
  PCIRCLE(xpos + NIKEI / 2, ypos + NIKEI / 5, NIKEI * 3 / 10 + DIAW, 0, PI / 2);
  PLINE(xpos + NIKEI / 2 + NIKEI * 3 / 10,ypos + NIKEI / 5,
                  xpos + ALFUCK - RWIRE, ypos - RADIA);
  PLINE(xpos + NIKEI / 2 + NIKEI * 3 / 10 + DIAW, ypos + NIKEI / 5,
                  xpos + ALFUCK + RWIRE, ypos - RADIA);
  PLINE(xpos + NIKEI / 2, ypos - ADIA / 2 + RWIRE,
                  xpos + NIKEI / 2,ypos - ADIA / 2 - RWIRE);
{RC}
  Printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PLINE(xpos + ALFUCK + PICH * (I - 1) + RWIRE * COS(CKAKU),
                           ypos - (RADIA + RWIRE * SIN(CKAKU)),
                           xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                           ypos + (RADIA - RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * (I - 1) - RWIRE * COS(CKAKU),
                           ypos - (RADIA - RWIRE * SIN(CKAKU)),
                           xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                           ypos +(RADIA + RWIRE * SIN(CKAKU)));
    end;
  if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                   else Printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PCIRCLE(xpos + ALFUCK + PICH * I,
        	             ypos - RADIA,RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2,
        	             ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
        	           ypos - (RADIA - RWIRE * SIN(CKAKU)),
                           xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                           ypos + (RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
        	           ypos -(RADIA + RWIRE * SIN(CKAKU)),
                           xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                           ypos +( RADIA - RWIRE * SIN(CKAKU)));
    end;
{EtbN}
  I := Ns;
  cnan := NT mod 4;
  if cnan = 0 then
    begin
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, NIKEI / 2, PI + PI / 2, PI / 2);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, GIKEI / 2, PI + PI / 2, PI / 2);
      PCIRCLE(xpos + JIUCH - ALFUCK, ypos - RADIA, RWIRE, PI, 2 * PI);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos + NIKEI / 5, NIKEI * 3 / 10, PI / 2, PI);
      PCIRCLE (xpos + JIUCH - NIKEI / 2,ypos + NIKEI / 5,
                             NIKEI * 3 / 10 + DIAW, PI / 2, PI);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI * 3 / 10, ypos + NIKEI / 5,
                                  xpos + JIUCH - ALFUCK + RWIRE, ypos - RADIA);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI * 3 / 10 - DIAW, ypos + NIKEI / 5,
                                  xpos + JIUCH - ALFUCK + RWIRE - DIAW, ypos - RADIA);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - NIKEI / 2,
                                  xpos + JIUCH - NIKEI / 2, ypos - GIKEI / 2);
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu,
                          xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu);
    end;
{OBTtbN}
  if cnan = 2 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
                          ypos - RADIA - RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                          ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE (xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
                           ypos - RADIA + RWIRE * SIN(CKAKU),
                           xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                           ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, NIKEI / 2, PI + PI / 2, PI / 2);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, GIKEI / 2, PI + PI / 2, PI / 2);
      PCIRCLE(xpos + JIUCH - ALFUCK, ypos + RADIA, RWIRE, 0, PI);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos - NIKEI / 5, NIKEI * 3 / 10, PI, PI + PI / 2);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos - NIKEI / 5,
                                    NIKEI * 3 / 10 + DIAW, PI, PI + PI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI * 3 / 10, ypos - NIKEI / 5,
                          xpos + JIUCH - ALFUCK + RWIRE, ypos + RADIA);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI * 3 / 10 - DIAW, ypos - NIKEI / 5,
                          xpos + JIUCH - ALFUCK - RWIRE, ypos + RADIA);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + NIKEI / 2,
                          xpos + JIUCH - NIKEI / 2, ypos + GIKEI / 2);
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2,ypos - RADIA - DIAW - 5 * Pkeisu,
                          xpos + JIUCH - NIKEI / 2,ypos + RADIA + DIAW + 5 * Pkeisu);
    end;
{OBQT}
  if cnan = 1 then
    begin
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PCIRCLE(xpos + RDXPOS, ypos - RADIA * 3 / 5, RADIA * 3 / 5 - RWIRE, PI / 2, PI - CKAKU);
      PCIRCLE(xpos + RDXPOS, ypos - RADIA * 3 / 5, RADIA * 3 / 5 + RWIRE, PI / 2, PI - CKAKU);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE, xpos + RDXPOS, ypos - RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE, xpos + RDXPOS, ypos + RWIRE);
      PLINE(xpos + RDXPOS - (RADIA * 3 / 5 + RWIRE) * COS(CKAKU),
                                 ypos - RADIA * 3 / 5 + (RADIA * 3 / 5 + RWIRE) * SIN(CKAKU),
                                 xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
                                 ypos - RADIA + RWIRE * SIN(CKAKU));
      PLINE(xpos + RDXPOS - (RADIA * 3 / 5 - RWIRE) * COS(CKAKU),
                          ypos - RADIA * 3 / 5 + (RADIA * 3 / 5 - RWIRE) * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
                          ypos - RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + RWIRE,
                          xpos + JIUCH - NIKEI / 2, ypos - RWIRE);
      PLINE(xpos + JIUCH - RADIA + RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA + RWIRE, ypos + RWIRE);
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - DIAW - 5 * Pkeisu,
                          xpos + JIUCH - NIKEI / 2, ypos + DIAW + 5 * Pkeisu);
    end;
 {OBVT}
  if cnan = 3 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I  + RWIRE * COS(CKAKU),
                        ypos - RADIA - RWIRE * SIN(CKAKU),
                        xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                        ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
                        ypos - RADIA + RWIRE * SIN(CKAKU),
                        xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                        ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + ALFUCK + PICH * I + PICH / 2,
                            ypos + RADIA, RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PCIRCLE(xpos + RDXPOS, ypos + RADIA * 3 / 5,
                            RADIA * 3 / 5 - RWIRE, PI + CKAKU, PI + PI / 2);
      PCIRCLE(xpos + RDXPOS, ypos + RADIA * 3 / 5,
                            RADIA * 3 / 5 + RWIRE, PI + CKAKU, PI + PI / 2);
      PLINE(xpos + RDXPOS - (RADIA * 3 / 5 - RWIRE) * COS(CKAKU),
                                 ypos + RADIA * 3 / 5 - (RADIA * 3 / 5 + RWIRE) * SIN(CKAKU),
                                 xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                                 ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + RDXPOS -(RADIA * 3 / 5 + RWIRE) * COS(CKAKU),
                        ypos + RADIA * 3 / 5 - (RADIA * 3 / 5 + RWIRE) * SIN(CKAKU),
                        xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                        ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,
                        xpos + JIUCH - ALFUCK
                        + SIN((PI / 2 - CKAKU) / 2) / COS((PI / 2 - CKAKU) / 2) * RADIA * 3 / 5,
                        ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE,
                        xpos + JIUCH - ALFUCK
                        + SIN((PI / 2 - CKAKU) / 2) / COS((PI / 2 - CKAKU) / 2) * RADIA * 3 / 5,
                        ypos - RWIRE);
      PLINE(xpos + JIUCH - RADIA + RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA + RWIRE, ypos + RWIRE);
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - DIAW - 5 * Pkeisu,
                          xpos + JIUCH - NIKEI / 2, ypos + DIAW + 5 * Pkeisu);
    end;
  PLINE(xpos - DIAW - 5 * Pkeisu, ypos, xpos + JIUCH + DIAW + 5 * Pkeisu, ypos);
  PLINE(xpos + NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
                  xpos + NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
end;

procedure PGAKUSITI (xpos,ypos,leng,a,d,na,keisu,A4: Double);
var
  I,Ns,cnan,NT:                                     integer;
  SITEI,DPI:                                        Double;
  ADIA,DIAW,JIUCH,NIKEI,GIKEI,RWIRE,RADIA,GFUCK: Double;
  LFUCK,ALFUCK,LFUCKS,LFUCKT,QFUCKS,QFUCKT,QCALC:   Double;
  PICH,CKAKU:                                       Double;
begin
  SITEI := A4 * keisu;{w蒷}
  Ns := round(int(na));
  NT := round(na * 4);
  ADIA := a * keisu;  {a}
  DIAW := d * keisu;  {a}
  JIUCH := leng * keisu;{R}
  NIKEI := ADIA - DIAW;{a}
  GIKEI := ADIA + DIAW;{Oa}
  RWIRE := DIAW / 2;{a}
  RADIA := ADIA / 2;{a}
  Printer.Canvas.Pen.Color := ClBlack;
  Printer.Canvas.Brush.Style := bsClear;
  if SITEI <= NIKEI / 2 + SIN(PI / 6) * RADIA then DPI := 0
         	                                    else DPI := PI;
  GFUCK := NIKEI * 1.1;{tbN}
  LFUCK := GFUCK - NIKEI / 2 + RWIRE;
  ALFUCK := LFUCK + NIKEI / 2;
  LFUCKS := SQRT(SQR(LFUCK) + SQR(RADIA));
  LFUCKT := SQRT(SQR(LFUCKS) - SQR(RADIA));
  QFUCKS := ARCTAN((RADIA) / LFUCKT);
  QFUCKT := ARCTAN(LFUCK / (RADIA));
  QCALC := QFUCKT - QFUCKS;
{tbN}
  if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                   else Printer.Canvas.Pen.Width := 1;
  PCIRCLE(xpos + NIKEI / 2, ypos, NIKEI / 2, QCALC, PI + PI / 2 + PI / 6);
  PCIRCLE(xpos + NIKEI / 2, ypos, GIKEI / 2, QCALC, PI + PI / 2 + PI / 6);
  PCIRCLE(xpos + ALFUCK, ypos - RADIA, RWIRE, PI + QCALC, QCALC);
  PLINE(xpos + NIKEI / 2 + GIKEI / 2 * COS(QCALC), ypos + GIKEI / 2 * SIN(QCALC),
        	  xpos + GFUCK + RWIRE + RWIRE * COS(QCALC), ypos - RADIA - RWIRE * SIN(QCALC));
  PLINE(xpos + NIKEI / 2 + NIKEI / 2 * COS(QCALC), ypos +NIKEI / 2 * SIN(QCALC),
    		    xpos + GFUCK + RWIRE - RWIRE * COS(QCALC), ypos - RADIA - RWIRE * SIN(QCALC));
  PLINE(xpos + NIKEI / 2 + NIKEI / 2 * SIN(PI / 6), ypos - NIKEI / 2 * COS(PI / 6),
        	  xpos + NIKEI / 2 + GIKEI / 2 * SIN(PI / 6), ypos - GIKEI / 2 * COS(PI / 6));
{RC}
  PICH := (JIUCH - ALFUCK - SITEI- RWIRE) / na;
  CKAKU:= ARCTAN(PICH / 2 / ADIA);
  Printer.Canvas.Pen.Width := 1;
  for I := 1 To Ns do
    begin
      PLINE(xpos + ALFUCK + PICH * (I - 1) + RWIRE * COS(CKAKU),
                            ypos - (RADIA + RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                            ypos +( RADIA - RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * (I - 1) - RWIRE * COS(CKAKU),
        	                  ypos -( RADIA - RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                            ypos +(RADIA + RWIRE * SIN(CKAKU)));
    end;
  if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                  else Printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PCIRCLE(xpos + ALFUCK + PICH * I, ypos - RADIA, RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2, ypos + RADIA, RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
                            ypos - (RADIA - RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                            ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
        	                  ypos -( RADIA + RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                            ypos +( RADIA - RWIRE * SIN(CKAKU)));
    end;
  I := Ns;
  cnan := NT mod 4;
{EtbN}
  if cnan = 0 then
    begin
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, NIKEI / 2, PI + PI / 2, PI / 2 + DPI / 6);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, GIKEI / 2, PI + PI / 2, PI / 2 + DPI / 6);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos - RADIA, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - NIKEI / 2,
                            xpos + JIUCH - SITEI - RWIRE, ypos - NIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - GIKEI / 2,
                            xpos + JIUCH - SITEI - RWIRE, ypos - GIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(DPI / 6),
        	                  ypos + NIKEI / 2 * COS(DPI / 6),
                            xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(DPI / 6),
                            ypos + GIKEI / 2 * COS(DPI / 6));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu,
        	                  xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu);
    end;
{OBTtbN}
  if cnan = 2 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
         	                  ypos - RADIA - RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                            ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
         	                  ypos - RADIA + RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                            ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, NIKEI / 2, PI + PI / 2 - DPI / 6, PI / 2);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, GIKEI / 2, PI + PI / 2 - DPI / 6, PI / 2);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos + RADIA, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + GIKEI / 2,
        	                  xpos + JIUCH - SITEI - RWIRE, ypos + GIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + NIKEI / 2,
        	                  xpos + JIUCH - SITEI - RWIRE, ypos + NIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(DPI / 6),
         	                  ypos - NIKEI / 2 * COS(DPI / 6),
                            xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(DPI / 6),
                            ypos - GIKEI / 2 * COS(DPI / 6));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
        	                  xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
    end;
{OBQT}
  if cnan = 1 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - SITEI - RWIRE + RWIRE * COS(CKAKU),
        	                  ypos - RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
                            ypos - RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE - RWIRE * COS(CKAKU),
        	                  ypos + RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
                            ypos - RADIA + RWIRE * SIN(CKAKU));
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI * 2 - CKAKU, PI + PI / 2);
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,
        	                  xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos + RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos - RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PCIRCLE(xpos + ALFUCK + PICH * I, ypos - RADIA, RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2,
        	                  ypos + RADIA, RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
        	                  ypos - (RADIA - RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                            ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
        	                  ypos -( RADIA + RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                            ypos +( RADIA - RWIRE * SIN(CKAKU)));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - DIAW - 5 * Pkeisu,
                            xpos + JIUCH - NIKEI / 2, ypos + DIAW + 5 * Pkeisu);
    end;
//OBVT
  if cnan = 3 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I  + RWIRE * COS(CKAKU),
        	                  ypos - RADIA - RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                            ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + ALFUCK + PICH * I  - RWIRE * COS(CKAKU),
        	                  ypos - RADIA + RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                            ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + ALFUCK + PICH * I + PICH/2, ypos + RADIA,
                            RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI / 2, CKAKU);
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH - SITEI - RWIRE + RWIRE * COS(CKAKU),
        	                  ypos + RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                            ypos + RADIA + RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE - RWIRE * COS(CKAKU),
        	                  ypos - RWIRE * SIN(CKAKU),
                            xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                            ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos + RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos - RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE,
                            xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH - NIKEI / 2,ypos - DIAW - 5 * Pkeisu,
                            xpos + JIUCH - NIKEI / 2,ypos + DIAW + 5 * Pkeisu);
    end;
  PLINE(xpos - DIAW - 5 * Pkeisu, ypos, xpos + JIUCH + DIAW + 5 * Pkeisu, ypos);
  PLINE(xpos + NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
        	  xpos + NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
end;

procedure PMALUSITI(xpos,ypos,leng,a,d,na,keisu,A4: Double);
var
  I,Ns,cnan,NT:                                     integer;
  ADIA,DIAW,JIUCH,NIKEI,GIKEI,RWIRE,RADIA,GFUCK: Double;
  LFUCK,ALFUCK,LFUCKS,LFUCKT,QFUCKS,QFUCKT,QCALC:   Double;
  PICH,CKAKU,SITEI,DPI:                             Double;
begin
  Ns := round(int(na));
  NT := round(na * 4);
  SITEI:= A4 * keisu;
  ADIA := a * keisu;            {a}
  DIAW := d * keisu;            {a}
  JIUCH := leng * keisu;        {}
  NIKEI := ADIA - DIAW;       {a}
  GIKEI := ADIA + DIAW;       {Oa}
  RWIRE := DIAW / 2;            {a}
  RADIA := ADIA / 2;            {a}
  GFUCK := NIKEI * 0.8;          {tbN}
  LFUCK := GFUCK - NIKEI / 2 + RWIRE;
  ALFUCK := LFUCK + NIKEI / 2;
  LFUCKS := SQRT(SQR(LFUCK)+ SQR(RADIA));
  LFUCKT := SQRT(SQR(LFUCKS) - SQR(RADIA));
  QFUCKS := ARCTAN(RADIA / LFUCKT);
  QFUCKT := ARCTAN(LFUCK / RADIA);
  QCALC := QFUCKT - QFUCKS;
  PICH := (JIUCH - ALFUCK - SITEI - RWIRE) / na;
  CKAKU:= ARCTAN(PICH / 2 / ADIA);
  Printer.Canvas.Pen.Color := clBlack;
  Printer.Canvas.Brush.Style := bsClear;
  if SITEI <= NIKEI / 2 + SIN(PI / 6) * RADIA then DPI := 0
                                              else DPI := PI;
{tbN}
  if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
    	            else Printer.Canvas.Pen.Width := 1;
  PCIRCLE(xpos + NIKEI / 2, ypos, NIKEI / 2, PI / 2, PI + PI / 2);
  PCIRCLE(xpos + NIKEI / 2, ypos, GIKEI / 2, PI / 2, PI + PI / 2);
  PCIRCLE(xpos + ALFUCK, ypos - RADIA, RWIRE, PI, 2 * PI);
  PCIRCLE(xpos + NIKEI / 2, ypos + NIKEI / 5, NIKEI * 3 / 10, 0, PI / 2);
  PCIRCLE(xpos + NIKEI / 2, ypos + NIKEI / 5, NIKEI * 3 / 10 + DIAW, 0, PI / 2);
  PLINE(xpos + NIKEI / 2 + NIKEI * 3 / 10, ypos + NIKEI / 5,
                        xpos + ALFUCK - RWIRE, ypos - RADIA);
  PLINE(xpos + NIKEI / 2 + NIKEI * 3 / 10 + DIAW, ypos + NIKEI / 5,
                        xpos + ALFUCK + RWIRE, ypos - RADIA);
  PLINE(xpos + NIKEI / 2,ypos - ADIA / 2 + RWIRE,
                        xpos + NIKEI / 2,ypos - ADIA / 2 - RWIRE);
{RC}
  Printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PLINE(xpos + ALFUCK + PICH * (I - 1) + RWIRE * COS(CKAKU),
                           ypos - (RADIA + RWIRE * SIN(CKAKU)),
                           xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                           ypos + (RADIA - RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * (I - 1) - RWIRE * COS(CKAKU),
                           ypos - (RADIA - RWIRE * SIN(CKAKU)),
                           xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                           ypos + (RADIA + RWIRE * SIN(CKAKU)));
    end;
  if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                  else printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PCIRCLE(xpos + ALFUCK + PICH * I, ypos - RADIA, RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2,
                            ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
                            ypos - (RADIA - RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                            ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
        	                  ypos -( RADIA + RWIRE * SIN(CKAKU)),
                            xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                            ypos +( RADIA - RWIRE * SIN(CKAKU)));
    end;
  I := Ns;
  cnan := NT mod 4;
{EtbN}
  if cnan = 0 then
    begin
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, NIKEI / 2, PI + PI / 2, PI / 2 + DPI / 6);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, GIKEI / 2, PI + PI / 2, PI / 2 + DPI / 6);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos - RADIA, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - NIKEI / 2,
                          xpos + JIUCH - SITEI - RWIRE, ypos - NIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2,ypos - GIKEI / 2,
                          xpos + JIUCH - SITEI - RWIRE, ypos - GIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(DPI / 6),
                          ypos + NIKEI / 2 * COS(DPI / 6),
                          xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(DPI / 6),
                          ypos + GIKEI / 2 * COS(DPI / 6));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu,
        	                xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5);
    	end;
{OBTtbN}
  if cnan = 2 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
                          ypos - RADIA - RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                          ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
                          ypos - RADIA + RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                          ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos,
                          NIKEI / 2, PI + PI / 2 - DPI / 6, PI / 2);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos,
                          GIKEI / 2, PI + PI / 2 - DPI / 6, PI / 2);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos + RADIA,
                          RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + GIKEI / 2,
                          xpos + JIUCH - SITEI - RWIRE, ypos + GIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + NIKEI / 2,
        	                xpos + JIUCH - SITEI - RWIRE, ypos + NIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(DPI / 6),
         	                ypos - NIKEI / 2 * COS(DPI / 6),
                          xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(DPI / 6),
                          ypos - GIKEI / 2 * COS(DPI / 6));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
        	                xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
    end;
{OBQT}
  if cnan = 1 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - SITEI - RWIRE + RWIRE * COS(CKAKU),
        	                ypos - RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
                          ypos - RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE - RWIRE * COS(CKAKU),
        	                ypos + RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
                          ypos - RADIA + RWIRE * SIN(CKAKU));
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI * 2 - CKAKU, PI + PI / 2);
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,
        	                xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PCIRCLE(xpos + ALFUCK + PICH * I, ypos - RADIA,RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + ALFUCK + PICH * I - PICH / 2,
        	                ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + ALFUCK + PICH * I + RWIRE * COS(CKAKU),
        	                ypos - (RADIA - RWIRE * SIN(CKAKU)),
                          xpos + ALFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                          ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + ALFUCK + PICH * I - RWIRE * COS(CKAKU),
        	                ypos -( RADIA + RWIRE * SIN(CKAKU)),
                          xpos + ALFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                          ypos +( RADIA - RWIRE * SIN(CKAKU)));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - DIAW - 5 * Pkeisu,
        	                xpos + JIUCH - NIKEI / 2, ypos + DIAW + 5 * Pkeisu);
    end;
//OBVT
  if cnan = 3 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + ALFUCK + PICH * I  + RWIRE * COS(CKAKU),
        	                ypos - RADIA - RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                          ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + ALFUCK + PICH * I  - RWIRE * COS(CKAKU),
        	                ypos - RADIA + RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                          ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + ALFUCK + PICH * I + PICH / 2, ypos + RADIA,
                          RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI / 2, CKAKU);
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH - SITEI - RWIRE + RWIRE * COS(CKAKU),
        	                ypos + RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                          ypos + RADIA + RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE - RWIRE * COS(CKAKU),
        	                ypos - RWIRE * SIN(CKAKU),
                          xpos + ALFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                          ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH - NIKEI / 2,ypos - DIAW - 5 * Pkeisu,
                          xpos + JIUCH - NIKEI / 2,ypos + DIAW + 5 * Pkeisu);
    end;
  PLINE(xpos - DIAW - 5 * Pkeisu, ypos, xpos + JIUCH + DIAW + 5 * Pkeisu, ypos);
  PLINE(xpos + NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
        	            xpos + NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
end;

procedure PRIYOSITEI(xpos,ypos,leng,a,d,na,keisu,A5,A6: Double);
var
  I,Ns,cnan,NT:                                  integer;
  ADIA,DIAW,JIUCH,NIKEI,GIKEI,RWIRE,RADIA,GFUCK: Double;
  LFUCK,LFUCKS,LFUCKT,QFUCKS,QFUCKT,QCALC:       Double;
  PICH,CKAKU,SITEI,LSITEI,LDPI,DPI:              Double;
begin
  Ns := round(int(na));
  NT := round(na * 4);
  LSITEI:=A5 * keisu;   {w蒷}
  SITEI:=A6 * keisu;     {Ew蒷}
  ADIA := a * keisu;            {a}
  DIAW := d * keisu;            {a}
  JIUCH := leng * keisu;        {}
  NIKEI := ADIA - DIAW;       {a}
  GIKEI := ADIA + DIAW;       {Oa}
  RWIRE := DIAW / 2;            {a}
  RADIA := ADIA / 2;            {a}
  GFUCK := LSITEI;          {tbN}
  LFUCK := LSITEI + RWIRE;
  LFUCKS := SQRT(SQR(LFUCK)+ SQR(RADIA));
  LFUCKT := SQRT(SQR(LFUCKS) - SQR(RADIA));
  QFUCKS := ARCTAN(RADIA / LFUCKT);
  QFUCKT := ARCTAN(LFUCK / RADIA);
  QCALC := QFUCKT - QFUCKS;
  PICH := (JIUCH - LFUCK - SITEI - RWIRE) / na;
  CKAKU:= ARCTAN(PICH / 2 / ADIA);
  Printer.Canvas.Brush.Style := bsClear;
  Printer.Canvas.Pen.Color := clBlack;
  if SITEI <= NIKEI / 2 + SIN(PI / 6) * RADIA then DPI := 0
                                              else DPI := PI;
  if LSITEI <= NIKEI / 2 + SIN(PI / 6) * RADIA then LDPI := 0
                                               else LDPI := PI;
{RC}
  for I := 1 to Ns do
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + LFUCK + PICH * (I - 1) + RWIRE * COS(CKAKU),
                            ypos - (RADIA + RWIRE * SIN(CKAKU)),
                            xpos + LFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                            ypos +( RADIA - RWIRE * SIN(CKAKU)));
      PLINE(xpos + LFUCK + PICH * (I - 1) - RWIRE * COS(CKAKU),
        	                  ypos -( RADIA - RWIRE * SIN(CKAKU)),
                            xpos + LFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                            ypos +(RADIA + RWIRE * SIN(CKAKU)));
    end;
  if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                  else Printer.Canvas.Pen.Width := 1;
  for I := 1 to Ns do
    begin
      PCIRCLE(xpos + LFUCK + PICH * I, ypos - RADIA,RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + LFUCK + PICH * I - PICH / 2, ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + LFUCK + PICH * I + RWIRE * COS(CKAKU),
                            ypos - (RADIA - RWIRE * SIN(CKAKU)),
                            xpos + LFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                            ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + LFUCK + PICH * I - RWIRE * COS(CKAKU),
                            ypos -( RADIA + RWIRE * SIN(CKAKU)),
                            xpos + LFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                            ypos +( RADIA - RWIRE * SIN(CKAKU)));
    end;
  I := Ns;
{tbN}
  if  RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                   else Printer.Canvas.Pen.Width := 1;
  PCIRCLE(xpos + NIKEI / 2, ypos, NIKEI / 2, PI / 2 - LDPI / 6, PI + PI / 2);
  PCIRCLE(xpos + NIKEI / 2, ypos, GIKEI / 2, PI / 2 - LDPI / 6, PI + PI / 2);
  PCIRCLE(xpos + LSITEI + RWIRE, ypos - RADIA, RWIRE, PI + PI / 2, PI / 2);
  PLINE(xpos + NIKEI / 2, ypos - NIKEI / 2, xpos + LSITEI + RWIRE, ypos - NIKEI / 2);
  PLINE(xpos + NIKEI / 2, ypos - GIKEI / 2, xpos + LSITEI + RWIRE, ypos - GIKEI / 2);
  PLINE(xpos + NIKEI / 2 + NIKEI / 2 * SIN(LDPI / 6),
                  ypos + NIKEI / 2 * COS(LDPI / 6),
                  xpos + NIKEI / 2 + GIKEI / 2 * SIN(LDPI / 6),
                  ypos + GIKEI / 2 * COS(LDPI / 6));
  Printer.Canvas.Pen.Width := 1;
  PLINE(xpos + NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
                  xpos + NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
//EtbN
  cnan := NT mod 4;
  if cnan = 0 then
    begin
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, NIKEI / 2, PI + PI / 2, PI / 2 + DPI / 6);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, GIKEI / 2, PI + PI / 2, PI / 2 + DPI / 6);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos - RADIA, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - NIKEI / 2,
                          xpos + JIUCH - SITEI - RWIRE, ypos - NIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - GIKEI / 2,
                          xpos + JIUCH - SITEI - RWIRE, ypos - GIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(DPI / 6),
        	                ypos + NIKEI / 2 * COS(DPI / 6),
                          xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(DPI / 6),
                          ypos + GIKEI / 2 * COS(DPI / 6));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu,
        	                xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu);
    end;
{OBTtbN}
  if cnan = 2 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + LFUCK + PICH * I + RWIRE * COS(CKAKU),
         	                ypos - RADIA - RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                          ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + LFUCK + PICH * I - RWIRE * COS(CKAKU),
         	                ypos - RADIA + RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                          ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, NIKEI / 2, PI + PI / 2 - DPI / 6, PI / 2);
      PCIRCLE(xpos + JIUCH - NIKEI / 2, ypos, GIKEI / 2, PI + PI / 2 - DPI / 6, PI / 2);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos + RADIA, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + GIKEI / 2,
        	                xpos + JIUCH - SITEI - RWIRE, ypos + GIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2, ypos + NIKEI / 2,
                          xpos + JIUCH - SITEI - RWIRE, ypos + NIKEI / 2);
      PLINE(xpos + JIUCH - NIKEI / 2 - NIKEI / 2 * SIN(DPI / 6),
         	                ypos - NIKEI / 2 * COS(DPI / 6),
                          xpos + JIUCH - NIKEI / 2 - GIKEI / 2 * SIN(DPI / 6),
                          ypos - GIKEI / 2 * COS(DPI / 6));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
        	                xpos + JIUCH - NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
    end;
{OBQT}
  if cnan = 1 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - SITEI - RWIRE + RWIRE * COS(CKAKU),
        	                ypos - RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I + RWIRE * COS(CKAKU),
                          ypos - RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE - RWIRE * COS(CKAKU),
        	                ypos + RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I - RWIRE * COS(CKAKU),
                          ypos - RADIA + RWIRE * SIN(CKAKU));
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI * 2 - CKAKU, PI + PI / 2);
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,
        	                xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI / 2, PI + PI / 2);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PCIRCLE(xpos + LFUCK + PICH * I, ypos - RADIA,RWIRE, PI - CKAKU, CKAKU);
      PCIRCLE(xpos + LFUCK + PICH * I - PICH / 2,
                          ypos + RADIA,RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PLINE(xpos + LFUCK + PICH * I + RWIRE * COS(CKAKU),
        	                ypos - (RADIA - RWIRE * SIN(CKAKU)),
                          xpos + LFUCK + PICH * I - PICH / 2 + RWIRE * COS(CKAKU),
                          ypos +( RADIA + RWIRE * SIN(CKAKU)));
      PLINE(xpos + LFUCK + PICH * I - RWIRE * COS(CKAKU),
        	                ypos -( RADIA + RWIRE * SIN(CKAKU)),
                          xpos + LFUCK + PICH * I - PICH / 2 - RWIRE * COS(CKAKU),
                          ypos +( RADIA - RWIRE * SIN(CKAKU)));
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - NIKEI / 2, ypos - DIAW - 5 * Pkeisu,
        	                xpos + JIUCH - NIKEI / 2, ypos + DIAW + 5 * Pkeisu);
    end;
{OBVT}
  if cnan = 3 then
    begin
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + LFUCK + PICH * I  + RWIRE * COS(CKAKU),
        	                ypos - RADIA - RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                          ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + LFUCK + PICH * I  - RWIRE * COS(CKAKU),
        	                ypos - RADIA + RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                          ypos + RADIA + RWIRE * SIN(CKAKU));
      if RWIRE >= 1.7 then Printer.Canvas.Pen.Width := 2
                      else Printer.Canvas.Pen.Width := 1;
      PCIRCLE(xpos + LFUCK + PICH * I + PICH / 2, ypos + RADIA,
                          RWIRE, 2 * PI - CKAKU, PI + CKAKU);
      PCIRCLE(xpos + JIUCH - SITEI - RWIRE, ypos, RWIRE, PI / 2, CKAKU);
      PCIRCLE(xpos + JIUCH + RWIRE, ypos, RWIRE, PI + PI / 2, PI / 2);
      PLINE(xpos + JIUCH - SITEI - RWIRE + RWIRE * COS(CKAKU),
        	                ypos + RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I + PICH / 2 + RWIRE * COS(CKAKU),
                          ypos + RADIA + RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE - RWIRE * COS(CKAKU),
        	                ypos - RWIRE * SIN(CKAKU),
                          xpos + LFUCK + PICH * I + PICH / 2 - RWIRE * COS(CKAKU),
                          ypos + RADIA - RWIRE * SIN(CKAKU));
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH - SITEI - RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE);
      PLINE(xpos + JIUCH + RWIRE, ypos - RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      Printer.Canvas.Pen.Width := 1;
      PLINE(xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos + RWIRE,
                          xpos + JIUCH - RADIA - RADIA * SIN(DPI / 6), ypos - RWIRE);
      PLINE(xpos + JIUCH - NIKEI / 2,ypos - DIAW - 5 * Pkeisu,
                          xpos + JIUCH - NIKEI / 2,ypos + DIAW + 5 * Pkeisu);
    end;
  PLINE(xpos - DIAW - 5 * Pkeisu, ypos, xpos + JIUCH + DIAW + 5 * Pkeisu, ypos);
  PLINE(xpos + NIKEI / 2, ypos - RADIA - DIAW - 5 * Pkeisu,
        	          xpos + NIKEI / 2, ypos + RADIA + DIAW + 5 * Pkeisu);
end;

end.

