unit HGraf;

interface
   procedure LINE(xpos1,ypos1,xpos2,ypos2: Double; col: integer);
   procedure COLORSet(col: integer);
   procedure CIRCLE(xpos,ypos,r: Double; col: integer; s,e: Double);
   procedure PAINT(xpos,ypos: Double; col, sel: integer);
   procedure OutGDBCS(xpos,ypos: Double; L: string; okisa: integer);
   procedure YA(YAXPOS, YAYPOS, Q:Double);
   procedure gformset;
   procedure A4A5A6leng;{tbNϊ}
   procedure calcstart;{vZJn}
   procedure jumyocheck3; {éAx̃Otɂ`FbN}
   procedure GAKUDEMO;{ }

implementation
uses Hspring, Graphics, Forms, datain, calc, Dataread,StdCtrls,Classes,
             SysUtils, Controls, Gyakumal,tauselect,startmenu,material,newinput,Buttons;

const Vposition = 400;//xWϊp@VpositionɏɕϊB

procedure BrushCOLOR(col: integer);
begin
  with Form1.Image1.Canvas.Brush do begin
    case col of
      0:  Color := clBlack;
     	1:  Color := clNavy;
     	2:  Color := clGreen;
     	3:  Color := clTeal;
     	4:  Color := clMaroon;
     	5:  Color := clPurple;
     	6:  Color := clOlive;
     	7:  Color := clSilver;
     	8:  Color := clGray;
     	9:  Color := clBlue;
     	10: Color := clLime;
     	11: Color := clAqua;
     	12: Color := clRed;
     	13: Color := clFuchsia;
     	14: Color := clYellow;
     	15: Color := clWhite;
     end;
  end;
end;

procedure COLORSet(col: integer);
begin
  with Form1.Image1.Canvas.Pen do begin
    case col of
     	0:  Color := clBlack;
     	1:  Color := clNavy;
     	2:  Color := clGreen;
     	3:  Color := clTeal;
     	4:  Color := clMaroon;
     	5:  Color := clPurple;
     	6:  Color := clOlive;
     	7:  Color := clSilver;
     	8:  Color := clGray;
     	9:  Color := clBlue;
     	10: Color := clLime;
     	11: Color := clAqua;
     	12: Color := clRed;
     	13: Color := clFuchsia;
     	14: Color := clYellow;
     	15: Color := clWhite;
    end;
  end;
  with Form1.Image1.Canvas.Font do begin
    case col of
     	0:  Color := clBlack;
     	1:  Color := clNavy;
     	2:  Color := clGreen;
     	3:  Color := clTeal;
     	4:  Color := clMaroon;
     	5:  Color := clPurple;
     	6:  Color := clOlive;
     	7:  Color := clSilver;
     	8:  Color := clGray;
     	9:  Color := clBlue;
     	10: Color := clLime;
     	11: Color := clAqua;
     	12: Color := clRed;
     	13: Color := clFuchsia;
     	14: Color := clYellow;
     	15: Color := clWhite;
    end;
  end;
end;

procedure LINE(xpos1,ypos1,xpos2,ypos2: Double; col: integer);
var
   X1,Y1,X2,Y2: integer;
begin
  X1 := round(xpos1);
  Y1 := Vposition - round(ypos1);//xWVpositionɏɕϊ
  X2 := round(xpos2);
  Y2 := Vposition - round(ypos2);//xWVpositionɏɕϊ
  COLORSet(col);
  Form1.Image1.Canvas.MoveTo(X1,Y1);
  Form1.Image1.Canvas.Lineto(X2,Y2);
end;

procedure CIRCLE(xpos,ypos,r: Double; col: integer; s,e: Double);
var
  XT,YT,XB,YB,SX,SY,EX,EY,HH: integer;
  HSY,HEY,SX1,SY1,EX1,EY1: integer;
  rbak: Double;
begin
  rbak := r;
  HH := Vposition;//xWVpositionɏɕϊ
  XT := round(xpos - r);
  YT := HH - round(ypos + r);
  XB := round(xpos + r);
  YB := HH - round(ypos - r);
  SX1 := round(xpos + cos(s) * r);
  HSY :=round(ypos + sin(s) * r);
  SY1 := HH - HSY;
  EX1 := round(xpos + cos(e) * r);
  HEY :=round(ypos + sin(e) * r);
  EY1 := HH -HEY;
  if r < 10 then r := r * 10;
  SX := round(xpos + cos(s) * r);
  HSY :=round(ypos + sin(s) * r);
  SY := HH - HSY;
  EX := round(xpos + cos(e) * r);
  HEY :=round(ypos + sin(e) * r);
  EY := HH - HEY;
  COLORSet(col);
  Form1.Image1.Canvas.Arc(XT, YT, XB, YB, SX, SY, EX, EY);
  if rbak <= 1 then
    begin
      Form1.Image1.Canvas.MoveTo(SX1,SY1);
      Form1.Image1.Canvas.Lineto(EX1,EY1);
  	end;
end;

procedure FILL(XX,YY,sel: integer);
begin
  with Form1.Image1.Canvas do begin
    case sel of
      0: FloodFill(XX,YY, clBlack, fsBorder);
      1: FloodFill(XX,YY, clNavy, fsBorder);
      2: FloodFill(XX,YY, clGreen, fsBorder);
      3: FloodFill(XX,YY, clTeal, fsBorder);
      4: FloodFill(XX,YY, clMaroon, fsBorder);
      5: FloodFill(XX,YY, clPurple, fsBorder);
      6: FloodFill(XX,YY, clOlive, fsBorder);
      7: FloodFill(XX,YY, clSilver, fsBorder);
      8: FloodFill(XX,YY, clGray, fsBorder);
      9: FloodFill(XX,YY, clBlue, fsBorder);
      10:FloodFill(XX,YY, clLime, fsBorder);
      11:FloodFill(XX,YY, clAqua, fsBorder);
      12:FloodFill(XX,YY, clRed, fsBorder);
      13:FloodFill(XX,YY, clFuchsia, fsBorder);
      14:FloodFill(XX,YY, clYellow, fsBorder);
      15:FloodFill(XX,YY, clWhite, fsBorder);
    end;
  end;
end;


procedure PAINT(xpos,ypos: Double; col, sel: integer);
var
  XX, YY: integer;
begin
  XX:= round(xpos);
  YY:= Vposition - round(ypos);//xWVpositionɏɕϊ
  { Form1.Image1.Canvas.Brush.Style := bsSolid;}
  {Form1.Image1.Canvas.Brush.Style := bsBDiagonal;}
  BrushCOLOR(col);
  Fill(XX, YY, sel);
end;

procedure OutGDBCS(xpos,ypos: Double; L: string; okisa: integer);
var
  XX, YY: integer;
begin
  okisa := okisa + 3;
  Form1.Image1.Canvas.Font.Height:= okisa;
  XX:= round(xpos);
  YY:= Vposition - round(ypos);
  Form1.Image1.Canvas.Brush.Style := bsClear;
  Form1.Image1.Canvas.Textout(XX,YY,L);
end;

procedure YA(YAXPOS,YAYPOS,Q: Double);
var
   XX, YY: integer;
   YAQ,QYAS,QYAE: Double;
   LENGYAS,LENGYAE,OFFYAS,OFFYAE: integer;
begin
  {HH:= Vposition;}
  XX:= round(YAXPOS);
  {YY:= HH - round(YAYPOS);}
  YY:= round(YAYPOS);
  YAQ:= PI/12;
  QYAS := Q + YAQ;
  QYAE := Q - YAQ;
  if QYAS > PI * 2 then QYAS := QYAS - PI * 2;
  if QYAE > PI * 2 then QYAE := QYAE - PI * 2;
  if QYAS < 0 then QYAS := QYAS + PI * 2;
  if QYAE < 0 then QYAE := QYAE + PI * 2;
  LENGYAS := round(COS(QYAS) * 10);
  LENGYAE := round(COS(QYAE) * 10);
  OFFYAS := round(SIN(QYAS) * 10);
  OFFYAE := round(SIN(QYAE) * 10);
  LINE (XX + LENGYAS, YY + OFFYAS, XX, YY, 0);
  LINE (XX, YY, XX + LENGYAE, YY + OFFYAE, 0);
end;

procedure gformset;//calc
var
  Cmp: Tcomponent;
  II : integer;
begin
  with Form1 do begin
    BorderStyle := bsNone;
    for II := 1 to 21 do
      begin
        if (II = 8) or (II = 10) or (II = 19) then
          else
          begin
            Cmp := FindComponent('Edit' + intTostr(II));
            TEdit(Cmp).Visible := False;
          end;
      end;
    for II := 1 to 5 do
      begin
        Cmp := FindComponent('Label' + intTostr(II));
        TLabel(cmp).Visible := False;
      end;
    for II := 1 to 11 do
      begin
        Cmp := FindComponent('bitbtn' + intTostr(II));
        Tbitbtn(cmp).Visible := False;
      end;
  end;
end;

procedure A4A5A6leng;{tbNϊ}
label
     fine;
var
  inda: string;
  I , Din,din1,SL: integer;
begin
  Din := 0;
  din1 := 0;
  //   SL := 0;
  inda := '';
  if (A3 = 3) or (A3 = 4) then inda := Form1.Edit4.Text;
  if (A3 = 5) then inda := Form1.Edit5.Text;
  SL := Length(inda);
  if SL = 0 then exit;
  for I:=1 to SL do
    begin
      case inda[I] of
        '0'..'9': ;
             '.': din1 := din1 +1;
               #0: Break;
          else
              Din:=9;
          end;
    end;
  if din1 > 1 then exit;
  if Din = 0 then
    begin
      if A3 = 5 then A5 := strTOfloat(inda);
      if (A3 = 3) or (A3 =4) then
        begin
          A4 := strTOfloat(inda);
          goto fine;
        end;
    end;
  if (A3 = 5) Then
    begin
      inda := Form1.Edit6.Text;
      SL := Length(inda);
      if SL = 0 then exit;
      din1 := 0;
      for I:=1 to SL do
        begin
          case inda[I] of
            '0'..'9': ;
                 '.': din1 := din1 + 1;
                  #0: Break;
            else
              Din:=9;
            end;
        end;
      if din1 > 1 then exit;
      if Din = 0 then
        begin
          A6 := strTOfloat(inda);
//          A4 := A5 + A6;
        end;
    end;
fine:
  if Din =0 then
    begin
      with Form1 do begin
        Edit4.Visible := False;
        Edit5.Visible := False;
        Edit6.Visible := False;
        Label3.Visible := False;
        Label4.Visible := False;
        Label5.Visible := False;
        hide;
      end;
      Form5.show;
      incheck := incheck or 4;
      indatadisp;//͂c`s`\  newinput
    end;
end;

procedure  calcstart;{vZJn}
begin
  dspmode := 2;
  if (MS = 'Y') or (MS = 'O') then diaconst;{awolvZ}
  if MS = 'K' then Kconst;{awolvZ}
  if MS = 'N' then D2mackcheck;{MAKE  CHHCK}
end;

procedure ZAINAMEdrow(TAUMIN,TAUMAX:Double);{x@Ot  \  ۂvbg}
var
  IB, ZAINB:       integer;
  YB,XB:              Double;
begin
  colorSet(0);
  OutGDBCS(16,100,NAMB[zai - 1],13);
  ZAINB := zai - 1;
  IB := 0;
  while DIA[IB] < d  do inc(IB);
  YB := (376 - 40) / 0.7 * TAUMAX / SWUSP[IB ,ZAINB] + 40;
  XB := (592 - 256) / 0.7 * TAUMIN / SWUSP[IB, ZAINB] + 256;
  with Form1.Image1.Canvas do begin
    Pen.Style := psSolid;
    Pen.Width := 2;
    Pen.Color := clOlive;
    Brush.Color := clRed;
    Ellipse(Round(XB - 5), Vposition - Round(YB + 5),//xWVpositionɏɕϊ
                                 Round(XB + 5), Vposition - Round(YB - 5));
    Pen.Width := 1;
    Brush.Color := clWhite;
  end;
end;

procedure jumyocheck3; {éAx̃Otɂ`FbN}
var
    SUTA, TAUMAX, TAUMIN:              Double;
begin
  Form1.show;
  Form4.hide;
  Form1.bitbtn11.Visible := False;
  grafHIROH;
  {y`hP`S@|sAm@T`V@XeX}
  SUTA := 1;
  if zai <= 4 then SUTA := 0.5 / 0.5;
  if (zai > 4) and (zai < 8) then SUTA := 0.45 / 0.5;
  TAUMIN := I * ((SPMIN - j) * KP + PAI) / ((S - j) * KP + PAI) / SUTA;
  TAUMAX := I * ((SPMAX - j) * KP + PAI) / ((S - j) * KP + PAI) / SUTA;
  ZAINAMEdrow(TAUMIN, TAUMAX);
  COLORSet(4);
  with Form1.Image1.Canvas do begin
    Font.height:= 14;
    Textout(40,5,'Ԋ|̒ɓĂ̂ǂB');
    COLORSet(4);
    Font.height:= 14;
    Textout(330, 335, 'Push  Enter Key');
  end;
  with Form1.Bitbtn10 do begin
    Font.Name := 'lr SVbN';
    Font.height := 14;
    height := 20;
    width := 60;
    top := 330;
    Left := 500;
    Visible := True;
    Caption := 'PUSH';
    SetFocus;
  end;
  jmode := 4;
end;

procedure GAKUDEMO;
var
   Fwide: integer;
   demstr:        string;
begin
  with Form1 do begin
    BorderStyle := bsNone;
    top := (Screen.Height - 400) div 2;
    Left:= (Screen.Width - 400) div 2;
    Height := 400;
    Width := 400;
    with Image2 do begin
      top := 0;
      left := 0;
      height := 400;
      width := 400;
      with Canvas do begin
        Font.Name := 'lr SVbN';
        Font.Style := [fsBold];
        Font.Height := 30;
        Font.Color := clBlack;
        Brush.Style := bsClear;
        demstr := 'XvO';
        Fwide := (Form1.Image2.width - TextWidth(demstr)) div 2;
        TextOut(Fwide,50,demstr);
        Font.Color := clRed;
        demstr := 'QOOW';
        Fwide := (Form1.Image2.width - TextWidth(demstr)) div 2;
        TextOut(Fwide,80,demstr);
      end;
    end;
  end;
end;

end.

